osmium::memory Namespace Reference

Memory management of items in buffers and iterators over this data. More...

## Classes

class | Buffer
class | Collection
class | CollectionIterator
class | Item
class | ItemIterator

## Typedefs

typedef uint32_t | item_size_type

## Functions

void | swap (Buffer &lhs, Buffer &rhs)
bool | operator== (const Buffer &lhs, const Buffer &rhs) noexcept
bool | operator!= (const Buffer &lhs, const Buffer &rhs) noexcept
template<typename TChar , typename TTraits , typename TMember >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const CollectionIterator< TMember > &iter)
template<typename T >
T | padded_length (T length) noexcept
template<typename TChar , typename TTraits , typename TMember >
std::basic_ostream< TChar, TTraits > & | operator<< (std::basic_ostream< TChar, TTraits > &out, const ItemIterator< TMember > &iter)

## Variables

constexpr item_size_type | align_bytes = 8

## Detailed Description

Memory management of items in buffers and iterators over this data.

## Typedef Documentation

typedef uint32_t osmium::memory::item_size_type

## Function Documentation

bool osmium::memory::operator!= | ( | const Buffer & | lhs,
|  | const Buffer & | rhs
| ) |  |

inline noexcept

template<typename TChar , typename TTraits , typename TMember >

std::basic_ostream<TChar, TTraits>& osmium::memory::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const ItemIterator< TMember > & | iter
| ) |  |

inline

template<typename TChar , typename TTraits , typename TMember >

std::basic_ostream<TChar, TTraits>& osmium::memory::operator<< | ( | std::basic_ostream< TChar, TTraits > & | out,
|  | const CollectionIterator< TMember > & | iter
| ) |  |

inline

bool osmium::memory::operator== | ( | const Buffer & | lhs,
|  | const Buffer & | rhs
| ) |  |

inline noexcept

Compare two buffers for equality.

Buffers are equal if they are both invalid or if they are both valid and have the same data pointer, capacity and committed data.

template<typename T >

T osmium::memory::padded_length | ( | T | length | ) |

inline noexcept

void osmium::memory::swap | ( | Buffer & | lhs,
|  | Buffer & | rhs
| ) |  |

inline

## Variable Documentation

constexpr item_size_type osmium::memory::align_bytes = 8